/* 2011.8.26
****************************************
**  Copyright  (C)        1999-2011   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  TC2.0@PC, KC7.0@MCS51             **
****************************************
*/

/*
********************************************** 
**
**  ʼCH438 4 
**
**********************************************
*/


#include"include.h"

/*
  ĬϵⲿʱƵ22.1184MHZ
*/
#define CH438UART4_BPS  19200            /* CH4384ͨѶ */
#define Fpclk           1843200         /* ڲʱƵ    */


/*********************************************************************************************************
** : InitCH438UART4
** : ãڳʼCH4384
** 䡡: 
**
** 䡡: 
**         
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/

void InitCH438UART4( void )       
{
    UINT16 div;
    UINT8 DLL, DLM;
/**************************************************************************
          CH4384ļĴ
**************************************************************************/
//    UART4_Reset();
    div = ( Fpclk >> 4 ) / CH438UART4_BPS;
    DLM = div >> 8;
    DLL = div & 0xff;
    WriteCH438Data( REG_LCR4_ADDR, BIT_LCR_DLAB );    /* DLABΪ1 */
    WriteCH438Data( REG_DLL4_ADDR, DLL );             /* ò */
    WriteCH438Data( REG_DLM4_ADDR, DLM );

    WriteCH438Data( REG_FCR4_ADDR, BIT_FCR_RECVTG1 | BIT_FCR_RECVTG0 | BIT_FCR_FIFOEN );    /* FIFOģʽΪ112ֽ */

    WriteCH438Data( REG_LCR4_ADDR, BIT_LCR_WORDSZ1 | BIT_LCR_WORDSZ0 );                     /* ֳ8λ1λֹͣλУ */

    WriteCH438Data( REG_IER4_ADDR, /*BIT_IER_IEMODEM |*/ BIT_IER_IELINES | BIT_IER_IETHRE | BIT_IER_IERECV );    /* ʹж */

    WriteCH438Data( REG_MCR4_ADDR, BIT_MCR_OUT2    | BIT_MCR_RTS     | BIT_MCR_DTR );              /* ж,DTR,RTSΪ1 */

    WriteCH438Data(REG_FCR4_ADDR,ReadCH438Data(REG_FCR4_ADDR)| BIT_FCR_TFIFORST|BIT_FCR_RFIFORST);

}



/*********************************************************************************************************
** : UART4_Reset
** : ܺڸλCH4384, λ֮Ҫ³ʼ ſʹ
** 䡡: 
**
** 䡡: 
**         
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void UART4_Reset( void )
{

    WriteCH438Data( REG_IER4_ADDR, BIT_IER_RESET ); 

}




/*********************************************************************************************************
** : UART4_LowPower
** : ܺCH4384͹ģʽ
** 䡡: 
**
** 䡡: 
**         
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void UART4_LowPower( void )
{

    WriteCH438Data( REG_IER4_ADDR, BIT_IER_LOWPOWER ); 

}




/*********************************************************************************************************
** : UART4_SendByte
** : ܺCH4384 ͵ֽ
** 䡡: 
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void UART4_SendByte( UINT8 dat )    
{

    while( ( ReadCH438Data( REG_LSR4_ADDR ) & BIT_LSR_THRE ) == 0 );    /* ȴݷ */

    WriteCH438Data( REG_THR4_ADDR, dat );
}




/*********************************************************************************************************
** : UART4_RcvByte
** : ܺCH4384 յֽ
** 䡡: 
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
UINT8 UART4_RcvByte( void )    
{

    UINT8 Rcvdat;

    if( !( ReadCH438Data( REG_LSR4_ADDR ) & ( BIT_LSR_BREAKINT | BIT_LSR_FRAMEERR | BIT_LSR_PARERR | BIT_LSR_OVERR ) ) )    /*  b1-b4޴ */
    {

        while( ( ReadCH438Data( REG_LSR4_ADDR ) & BIT_LSR_DATARDY ) == 0 );    /* ȴ׼ */

        Rcvdat = ReadCH438Data( REG_RBR4_ADDR );    /* ӽջĴ */

        return( Rcvdat );
    }

    else ReadCH438Data( REG_RBR4_ADDR );    /* д */

}





/*********************************************************************************************************
** : UART4_SendStr
** : ܺCH4384 һַ
** 䡡: ַ
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void UART4_SendStr( UINT8 *str )    
{

    while( 1 )
    {

        if( *str == '\0' ) break;

        UART4_SendByte( *str++ );

    }

}


/*********************************************************************************************************
** : CH438Seril4Send
** : ܺFIFOģʽ, CH4384 Ͷֽ
** 䡡: ݿ
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void  CH438Seril4Send( UINT8 *Data, UINT8 Num )
{
    do
    {

        while( ( ReadCH438Data( REG_LSR4_ADDR ) & BIT_LSR_THRE ) == 0 );    /* ȴݷ */

        WriteCH438Data( REG_THR4_ADDR, *Data++ );

    }

    while( --Num );

}



/*********************************************************************************************************
** : CH438Seril4Rcv
** : ܺFIFOģʽ, CH4384 նֽ
** 䡡: ݻַ
**
** 䡡: ݳ
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/

UINT8  CH438Seril4Rcv( UINT8 *buf )
{
    UINT8 RcvNum = 0;

    if( !( ReadCH438Data( REG_LSR4_ADDR ) & ( BIT_LSR_BREAKINT | BIT_LSR_FRAMEERR | BIT_LSR_PARERR | BIT_LSR_OVERR ) ) )    /* b1-b4޴ */
    {

        while( ( ReadCH438Data( REG_LSR4_ADDR ) & BIT_LSR_DATARDY ) == 0 );    /* ȴ׼ */

        do
        {

            *buf++ = ReadCH438Data( REG_RBR4_ADDR );                           /* ӽջĴ */

            RcvNum++;

        }

        while( ( ReadCH438Data( REG_LSR4_ADDR ) & BIT_LSR_DATARDY ) == 0x01 );
									   
    }

    else ReadCH438Data( REG_RBR4_ADDR );

    return( RcvNum );
}








/*********************************************************************************************************
** : CH438UART4Send
** : ܺFIFOģʽ, CH4384 Ͷֽ ෢128ֽ
** 䡡: ݻַ, ݿ鳤
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void  CH438UART4Send( UINT8 *Data, UINT8 Num )
{

    while( 1 )
    {

        while( ( ReadCH438Data( REG_LSR4_ADDR ) & BIT_LSR_TEMT ) == 0 );    /* ȴݷϣTHR,TSRȫ */

        if( Num <= 128 )
        {

            WriteCH438Block( REG_THR4_ADDR, Num, Data );

            break;

        }

        else
        {

            WriteCH438Block( REG_THR4_ADDR, 128, Data );

            Num -= 128;

            Data += 128;

        }

    }
}



/*********************************************************************************************************
** : Auto_HandFlow4_Ctrl
** : ܺ4ԶӲ
** 䡡: 
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void Auto_HandFlow4_Ctrl( void )
{

    WriteCH438Data( REG_MCR4_ADDR, BIT_MCR_AFE | BIT_MCR_OUT2 | BIT_MCR_RTS );    /* MCRĴAFERTSΪ1 */

}


