/* 2011.8.26
****************************************
**  Copyright  (C)        1999-2011   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  TC2.0@PC, KC7.0@MCS51             **
****************************************
*/

/*
********************************************** 
**
**  ʼCH438 7 
**
**********************************************
*/


#include"include.h"

/*
  ĬϵⲿʱƵ22.1184MHZ
*/
#define CH438UART7_BPS  115200            /* CH4387ͨѶ */
#define Fpclk           1843200         /* ڲʱƵ    */


/*********************************************************************************************************
** : InitCH438UART7
** : ãڳʼCH4387
** 䡡: 
**
** 䡡: 
**         
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/

void InitCH438UART7( void )       
{
    UINT16 div;
    UINT8 DLL, DLM;
/**************************************************************************
          CH4387ļĴ
**************************************************************************/
//    UART7_Reset();
    div = ( Fpclk >> 4 ) / CH438UART7_BPS;
    DLM = div >> 8;
    DLL = div & 0xff;
    WriteCH438Data( REG_LCR7_ADDR, BIT_LCR_DLAB );    /* DLABΪ1 */
    WriteCH438Data( REG_DLL7_ADDR, DLL );             /* ò */
    WriteCH438Data( REG_DLM7_ADDR, DLM );

    WriteCH438Data( REG_FCR7_ADDR, BIT_FCR_RECVTG1 | BIT_FCR_RECVTG0 | BIT_FCR_FIFOEN );    /* FIFOģʽΪ112ֽ */

    WriteCH438Data( REG_LCR7_ADDR, BIT_LCR_WORDSZ1 | BIT_LCR_WORDSZ0 );                     /* ֳ8λ1λֹͣλУ */

    WriteCH438Data( REG_IER7_ADDR, /*BIT_IER_IEMODEM |*/ BIT_IER_IELINES | BIT_IER_IETHRE | BIT_IER_IERECV );    /* ʹж */

    WriteCH438Data( REG_MCR7_ADDR, BIT_MCR_OUT2    | BIT_MCR_RTS     | BIT_MCR_DTR );              /* ж,DTR,RTSΪ1 */

    WriteCH438Data(REG_FCR7_ADDR,ReadCH438Data(REG_FCR7_ADDR)| BIT_FCR_TFIFORST|BIT_FCR_RFIFORST);

}



/*********************************************************************************************************
** : UART7_Reset
** : ܺڸλCH4387, λ֮Ҫ³ʼ ſʹ
** 䡡: 
**
** 䡡: 
**         
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void UART7_Reset( void )
{

    WriteCH438Data( REG_IER7_ADDR, BIT_IER_RESET ); 

}




/*********************************************************************************************************
** : UART7_LowPower
** : ܺCH4387͹ģʽ
** 䡡: 
**
** 䡡: 
**         
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void UART7_LowPower( void )
{

    WriteCH438Data( REG_IER7_ADDR, BIT_IER_LOWPOWER ); 

}




/*********************************************************************************************************
** : UART7_SendByte
** : ܺCH4387 ͵ֽ
** 䡡: 
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void UART7_SendByte( UINT8 dat )    
{

    while( ( ReadCH438Data( REG_LSR7_ADDR ) & BIT_LSR_THRE ) == 0 );    /* ȴݷ */

    WriteCH438Data( REG_THR7_ADDR, dat );
}




/*********************************************************************************************************
** : UART7_RcvByte
** : ܺCH4387 յֽ
** 䡡: 
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
UINT8 UART7_RcvByte( void )    
{

    UINT8 Rcvdat;

    if( !( ReadCH438Data( REG_LSR7_ADDR ) & ( BIT_LSR_BREAKINT | BIT_LSR_FRAMEERR | BIT_LSR_PARERR | BIT_LSR_OVERR ) ) )    /*  b1-b4޴ */
    {

        while( ( ReadCH438Data( REG_LSR7_ADDR ) & BIT_LSR_DATARDY ) == 0 );    /* ȴ׼ */

        Rcvdat = ReadCH438Data( REG_RBR7_ADDR );    /* ӽջĴ */

        return( Rcvdat );
    }

    else ReadCH438Data( REG_RBR7_ADDR );    /* д */

}





/*********************************************************************************************************
** : UART7_SendStr
** : ܺCH4387 һַ
** 䡡: ַ
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void UART7_SendStr( UINT8 *str )    
{

    while( 1 )
    {

        if( *str == '\0' ) break;

        UART7_SendByte( *str++ );

    }

}


/*********************************************************************************************************
** : CH438Seril7Send
** : ܺFIFOģʽ, CH4387 Ͷֽ
** 䡡: ݿ
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void  CH438Seril7Send( UINT8 *Data, UINT8 Num )
{
    do
    {

        while( ( ReadCH438Data( REG_LSR7_ADDR ) & BIT_LSR_THRE ) == 0 );    /* ȴݷ */

        WriteCH438Data( REG_THR7_ADDR, *Data++ );

    }

    while( --Num );

}



/*********************************************************************************************************
** : CH438Seril7Rcv
** : ܺFIFOģʽ, CH4387 նֽ
** 䡡: ݻַ
**
** 䡡: ݳ
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/

UINT8  CH438Seril7Rcv( UINT8 *buf )
{
    UINT8 RcvNum = 0;

    if( !( ReadCH438Data( REG_LSR7_ADDR ) & ( BIT_LSR_BREAKINT | BIT_LSR_FRAMEERR | BIT_LSR_PARERR | BIT_LSR_OVERR ) ) )    /* b1-b4޴ */
    {

        while( ( ReadCH438Data( REG_LSR7_ADDR ) & BIT_LSR_DATARDY ) == 0 );    /* ȴ׼ */

        do
        {

            *buf++ = ReadCH438Data( REG_RBR7_ADDR );                           /* ӽջĴ */

            RcvNum++;

        }

        while( ( ReadCH438Data( REG_LSR7_ADDR ) & BIT_LSR_DATARDY ) == 0x01 );
									   
    }

    else ReadCH438Data( REG_RBR7_ADDR );

    return( RcvNum );
}








/*********************************************************************************************************
** : CH438UART7Send
** : ܺFIFOģʽ, CH4387 Ͷֽ ෢128ֽ
** 䡡: ݻַ, ݿ鳤
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void  CH438UART7Send( UINT8 *Data, UINT8 Num )
{

    while( 1 )
    {

        while( ( ReadCH438Data( REG_LSR7_ADDR ) & BIT_LSR_TEMT ) == 0 );    /* ȴݷϣTHR,TSRȫ */

        if( Num <= 128 )
        {

            WriteCH438Block( REG_THR7_ADDR, Num, Data );

            break;

        }

        else
        {

            WriteCH438Block( REG_THR7_ADDR, 128, Data );

            Num -= 128;

            Data += 128;

        }

    }
}



/*********************************************************************************************************
** : Auto_HandFlow7_Ctrl
** : ܺ7ԶӲ
** 䡡: 
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void Auto_HandFlow7_Ctrl( void )
{

    WriteCH438Data( REG_MCR7_ADDR, BIT_MCR_AFE | BIT_MCR_OUT2 | BIT_MCR_RTS );    /* MCRĴAFERTSΪ1 */

}


