/* 2011.8.26
****************************************
**  Copyright  (C)        1999-2011   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  TC2.0@PC, KC7.0@MCS51             **
****************************************
*/

/*
********************************************** 
**
**  CH438 תമڽӿоƬ 
**
**  Գ  ʼUART0-UART7 (1200~115200)
**  õƬⲿжϷʽ   
**
**********************************************
*/



#include"include.h"

unsigned char buf[128];


UINT8 UART0_STRING[ ] = {" I am UART0 \n" };
UINT8 UART1_STRING[ ] = {" I am UART1 \n" };
UINT8 UART2_STRING[ ] = {" I am UART2 \n" };
UINT8 UART3_STRING[ ] = {" I am UART3 \n" };
UINT8 UART4_STRING[ ] = {" I am UART4 \n" };
UINT8 UART5_STRING[ ] = {" I am UART5 \n" };
UINT8 UART6_STRING[ ] = {" I am UART6 \n" };
UINT8 UART7_STRING[ ] = {" I am UART7 \n" };

/*
  ʼƬ
*/
void InitStdio( void )
{
	SCON = 0xd0;
	PCON = 0x80;
	TMOD = 0x20;
	TH1 = 0xf4;  /* 22.1184MHz, 9600bps */
//	TH1 = 0xfa;  /* 11.0592MHz, 9600bps */
	TR1 = 1;
	TI = 1;
}

/* ʱ100,ȷ */
void	mDelay100mS( )
{
	unsigned char	i, j, c;
	for ( i = 200; i != 0; i -- ) for ( j = 200; j != 0; j -- ) c+=3;
}




void CH438Interrupt( ) interrupt 0    /* жϷʽ */
{
    UINT8 gInterruptStatus;		/* ȫж״̬ */
	UINT8 InterruptStatus;		/* ж״̬ */
    UINT8 RcvNum = 0, s;
    UINT8 ModemStatus;
    
	EX0 = 0;       /* رINT0 ж */
	gInterruptStatus = ReadCH438Data( REG_SSR_ADDR );
    
	if( gInterruptStatus & 0x01  )    /* ⴮0Ƿжϲ */
    {
        InterruptStatus = ReadCH438Data( REG_IIR_ADDR ) & ( ~ CH438_IIR_FIFOS_ENABLED );    /* 0ж״̬ */
        if( ( InterruptStatus & 0x01 ) ) return;    /* ûж˳ */
        else
        {
            switch( InterruptStatus )
             {
                case INT_NOINT:    /* ûж */
                     break;
                case INT_THR_EMPTY:    /* ͱּĴж */
//                    UART0_SendStr( "UART0 THR Empty \n" );
                    break;
                case INT_RCV_SUCCESS:    /* ڽտж */
                    RcvNum = CH438Seril0Rcv( buf );
                    CH438Seril0Send( buf, RcvNum );
                    break;
                case INT_RCV_LINES:    /* ·״̬ж */
                    ReadCH438Data( REG_LSR_ADDR);
                    break;
                case INT_RCV_OVERTIME:    /* ݳʱж */
                    RcvNum = CH438Seril0Rcv( buf );
                    CH438Seril0Send( buf, RcvNum );
                    break;
	            case INT_MODEM_CHANGE:
                    ModemStatus = ReadCH438Data( REG_MSR_ADDR );
                    UART0_SendStr( " Modem Change \n" );
                    if ( ModemStatus == 0x30 )        /* Modemźŷݱ仯 */
                     {
//                       UART0_SendStr( "DSR CTS is Free \n" );
                      }
                    else if ( ModemStatus == 0x11 )    /* Modem źŽݱ仯 */
                     {
//                      UART0_SendStr( "DSR CTS is Free \n" );
                      }
                    else if ( ModemStatus == 0x22 )    /* Modem źŽݱ仯 */
                     {
                       s = ReadCH438Data( REG_RBR_ADDR );
//                       UART0_SendStr( "DSR has changed \n" );
                       }
                     break;

                default:    /* ܷж */
                    break;
            }
        }
    }
 
	 if( gInterruptStatus & 0x02  )    /* ⴮1Ƿжϲ */
    {
        InterruptStatus = ReadCH438Data( REG_IIR1_ADDR ) & ( ~ CH438_IIR_FIFOS_ENABLED );    /* 1ж״̬ */
        if( ( InterruptStatus & 0x01 ) ) return;    /* ûж˳ */
        else
        {
            switch( InterruptStatus )
             {
                case INT_NOINT:    /* ûж */
                     break;
                case INT_THR_EMPTY:    /* ͱּĴж */
//                    UART1_SendStr( "UART1 THR Empty \n" );
                    break;
                case INT_RCV_SUCCESS:    /* ڽտж */
                    RcvNum = CH438Seril1Rcv( buf );
                    CH438Seril1Send( buf, RcvNum );
                    break;
                case INT_RCV_LINES:    /* ·״̬ж */
                    ReadCH438Data( REG_LSR1_ADDR);
                    break;
                case INT_RCV_OVERTIME:    /* ݳʱж */
                    RcvNum = CH438Seril1Rcv( buf );
                    CH438Seril1Send( buf, RcvNum );
                    break;
	            case INT_MODEM_CHANGE:
                    ModemStatus = ReadCH438Data( REG_MSR1_ADDR );
                    UART1_SendStr( " Modem Change \n" );
                    if ( ModemStatus == 0x30 )        /* Modemźŷݱ仯 */
                     {
//                    UART1_SendStr( SEND_STRING1 );
                      }
                    else if ( ModemStatus == 0x11 )    /* Modem źŽݱ仯 */
                     {
//                    WriteCH438Data( CH438_THR1_PORT, 0xAA );
                      }
                    else if ( ModemStatus == 0x22 )    /* Modem źŽݱ仯 */
                     {
                       s = ReadCH438Data( REG_RBR1_ADDR );
//                     WriteCH438Data( CH438_THR1_PORT, s );
                       }
                     break;

                default:    /* ܷж */
                    break;
            }
        }
    }


	 if( gInterruptStatus & 0x04  )    /* ⴮2Ƿжϲ */
    {
        InterruptStatus = ReadCH438Data( REG_IIR2_ADDR ) & ( ~ CH438_IIR_FIFOS_ENABLED );    /* 2ж״̬ */
        if( ( InterruptStatus & 0x01 ) ) return;    /* ûж˳ */
        else
        {
            switch( InterruptStatus )
             {
                case INT_NOINT:    /* ûж */
                     break;
                case INT_THR_EMPTY:    /* ͱּĴж */
//                    UART2_SendStr( "UART2 THR Empty \n" );
                    break;
                case INT_RCV_SUCCESS:    /* ڽտж */
                    RcvNum = CH438Seril2Rcv( buf );
                    CH438Seril2Send( buf, RcvNum );
                    break;
                case INT_RCV_LINES:    /* ·״̬ж */
                    ReadCH438Data( REG_LSR2_ADDR);
                    break;
                case INT_RCV_OVERTIME:    /* ݳʱж */
                    RcvNum = CH438Seril2Rcv( buf );
                    CH438Seril2Send( buf, RcvNum );
                    break;
	            case INT_MODEM_CHANGE:
                    ModemStatus = ReadCH438Data( REG_MSR2_ADDR );
                    UART2_SendStr( " Modem Change \n" );
                    if ( ModemStatus == 0x30 )        /* Modemźŷݱ仯 */
                     {
//                    UART2_SendStr( SEND_STRING1 );
                      }
                    else if ( ModemStatus == 0x11 )    /* Modem źŽݱ仯 */
                     {
//                    WriteCH438Data( CH438_THR2_PORT, 0xAA );
                      }
                    else if ( ModemStatus == 0x22 )    /* Modem źŽݱ仯 */
                     {
                       s = ReadCH438Data( REG_RBR2_ADDR );
//                     WriteCH438Data( CH438_THR2_PORT, s );
                       }
                     break;

                default:    /* ܷж */
                    break;
            }
        }
    }



	 if( gInterruptStatus & 0x08  )    /* ⴮3Ƿжϲ */
    {
        InterruptStatus = ReadCH438Data( REG_IIR3_ADDR ) & ( ~ CH438_IIR_FIFOS_ENABLED );    /* 3ж״̬ */
        if( ( InterruptStatus & 0x01 ) ) return;    /* ûж˳ */
        else
        {
            switch( InterruptStatus )
             {
                case INT_NOINT:    /* ûж */
                     break;
                case INT_THR_EMPTY:    /* ͱּĴж */
//                    UART3_SendStr( "UART3 THR Empty \n" );
                    break;
                case INT_RCV_SUCCESS:    /* ڽտж */
                    RcvNum = CH438Seril3Rcv( buf );
                    CH438Seril3Send( buf, RcvNum );
                    break;
                case INT_RCV_LINES:    /* ·״̬ж */
                    ReadCH438Data( REG_LSR3_ADDR);
                    break;
                case INT_RCV_OVERTIME:    /* ݳʱж */
                    RcvNum = CH438Seril3Rcv( buf );
                    CH438Seril3Send( buf, RcvNum );
                    break;
	            case INT_MODEM_CHANGE:
                    ModemStatus = ReadCH438Data( REG_MSR3_ADDR );
                    UART3_SendStr( " Modem Change \n" );
                    if ( ModemStatus == 0x30 )        /* Modemźŷݱ仯 */
                     {
//                      UART3_SendStr( "DSR CTS is Free \n" );
                      }
                    else if ( ModemStatus == 0x11 )    /* Modem źŽݱ仯 */
                     {
//                      UART3_SendStr( " CTS has changed \n" );
                      }
                    else if ( ModemStatus == 0x22 )    /* Modem źŽݱ仯 */
                     {
                       s = ReadCH438Data( REG_RBR3_ADDR );
//                       UART3_SendStr( "DSR has changed \n" );
                       }
                     break;

                default:    /* ܷж */
                    break;
            }
        }
    }


	 if( gInterruptStatus & 0x10  )    /* ⴮4Ƿжϲ */
    {
        InterruptStatus = ReadCH438Data( REG_IIR4_ADDR ) & ( ~ CH438_IIR_FIFOS_ENABLED );    /* 4ж״̬ */
        if( ( InterruptStatus & 0x01 ) ) return;    /* ûж˳ */
        else
        {
            switch( InterruptStatus )
             {
                case INT_NOINT:    /* ûж */
                     break;
                case INT_THR_EMPTY:    /* ͱּĴж */
//                    UART4_SendStr( "UART4 THR Empty \n" );
                    break;
                case INT_RCV_SUCCESS:    /* ڽտж */
                    RcvNum = CH438Seril4Rcv( buf );
                    CH438Seril4Send( buf, RcvNum );
                    break;
                case INT_RCV_LINES:    /* ·״̬ж */
                    ReadCH438Data( REG_LSR4_ADDR);
                    break;
                case INT_RCV_OVERTIME:    /* ݳʱж */
                    RcvNum = CH438Seril4Rcv( buf );
                    CH438Seril4Send( buf, RcvNum );
                    break;
	            case INT_MODEM_CHANGE:
                    ModemStatus = ReadCH438Data( REG_MSR4_ADDR );
                    UART4_SendStr( " Modem Change \n" );
                    if ( ModemStatus == 0x30 )        /* Modemźŷݱ仯 */
                     {
//                    UART0_SendStr( SEND_STRING1 );
                      }
                    else if ( ModemStatus == 0x11 )    /* Modem źŽݱ仯 */
                     {
//                    WriteCH438Data( CH438_THR_PORT, 0xAA );
                      }
                    else if ( ModemStatus == 0x22 )    /* Modem źŽݱ仯 */
                     {
                       s = ReadCH438Data( REG_RBR4_ADDR );
//                     WriteCH438Data( CH438_THR_PORT, s );
                       }
                     break;

                default:    /* ܷж */
                    break;
            }
        }
    }


	 if( gInterruptStatus & 0x20  )    /* ⴮5Ƿжϲ */
    {
        InterruptStatus = ReadCH438Data( REG_IIR5_ADDR ) & ( ~ CH438_IIR_FIFOS_ENABLED );    /* 5ж״̬ */
        if( ( InterruptStatus & 0x01 ) ) return;    /* ûж˳ */
        else
        {
            switch( InterruptStatus )
             {
                case INT_NOINT:    /* ûж */
                     break;
                case INT_THR_EMPTY:    /* ͱּĴж */
//                    UART5_SendStr( "UART5 THR Empty \n" );
                    break;
                case INT_RCV_SUCCESS:    /* ڽտж */
                    RcvNum = CH438Seril5Rcv( buf );
                    CH438Seril5Send( buf, RcvNum );
                    break;
                case INT_RCV_LINES:    /* ·״̬ж */
                    ReadCH438Data( REG_LSR5_ADDR);
                    break;
                case INT_RCV_OVERTIME:    /* ݳʱж */
                    RcvNum = CH438Seril5Rcv( buf );
                    CH438Seril5Send( buf, RcvNum );
                    break;
	            case INT_MODEM_CHANGE:
                    ModemStatus = ReadCH438Data( REG_MSR5_ADDR );
                    UART5_SendStr( " Modem Change \n" );
                    if ( ModemStatus == 0x30 )        /* Modemźŷݱ仯 */
                     {
//                    UART0_SendStr( SEND_STRING1 );
                      }
                    else if ( ModemStatus == 0x11 )    /* Modem źŽݱ仯 */
                     {
//                    WriteCH438Data( CH438_THR_PORT, 0xAA );
                      }
                    else if ( ModemStatus == 0x22 )    /* Modem źŽݱ仯 */
                     {
                       s = ReadCH438Data( REG_RBR5_ADDR );
//                     WriteCH438Data( CH438_THR_PORT, s );
                       }
                     break;

                default:    /* ܷж */
                    break;
            }
        }
    }


	 if( gInterruptStatus & 0x40  )    /* ⴮6Ƿжϲ */
    {
        InterruptStatus = ReadCH438Data( REG_IIR6_ADDR ) & ( ~ CH438_IIR_FIFOS_ENABLED );    /* 6ж״̬ */
        if( ( InterruptStatus & 0x01 ) ) return;    /* ûж˳ */
        else
        {
            switch( InterruptStatus )
             {
                case INT_NOINT:    /* ûж */
                     break;
                case INT_THR_EMPTY:    /* ͱּĴж */
//                    UART6_SendStr( "UART6 THR Empty \n" );
                    break;
                case INT_RCV_SUCCESS:    /* ڽտж */
                    RcvNum = CH438Seril6Rcv( buf );
                    CH438Seril6Send( buf, RcvNum );
                    break;
                case INT_RCV_LINES:    /* ·״̬ж */
                    ReadCH438Data( REG_LSR6_ADDR);
                    break;
                case INT_RCV_OVERTIME:    /* ݳʱж */
                    RcvNum = CH438Seril6Rcv( buf );
                    CH438Seril6Send( buf, RcvNum );
                    break;
	            case INT_MODEM_CHANGE:
                    ModemStatus = ReadCH438Data( REG_MSR6_ADDR );
                    UART6_SendStr( " Modem Change \n" );
                    if ( ModemStatus == 0x30 )        /* Modemźŷݱ仯 */
                     {
//                    UART0_SendStr( SEND_STRING1 );
                      }
                    else if ( ModemStatus == 0x11 )    /* Modem źŽݱ仯 */
                     {
//                    WriteCH438Data( CH438_THR_PORT, 0xAA );
                      }
                    else if ( ModemStatus == 0x22 )    /* Modem źŽݱ仯 */
                     {
                       s = ReadCH438Data( REG_RBR6_ADDR );
//                     WriteCH438Data( CH438_THR_PORT, s );
                       }
                     break;

                default:    /* ܷж */
                    break;
            }
        }
    }



	 if( gInterruptStatus & 0x80  )    /* ⴮7Ƿжϲ */
    {
        InterruptStatus = ReadCH438Data( REG_IIR7_ADDR ) & ( ~ CH438_IIR_FIFOS_ENABLED );    /* 7ж״̬ */
        if( ( InterruptStatus & 0x01 ) ) return;    /* ûж˳ */
        else
        {
            switch( InterruptStatus )
             {
                case INT_NOINT:    /* ûж */
                     break;
                case INT_THR_EMPTY:    /* ͱּĴж */
//                    UART7_SendStr( "UART7 THR Empty \n" );
                    break;
                case INT_RCV_SUCCESS:    /* ڽտж */
                    RcvNum = CH438Seril7Rcv( buf );
                    CH438Seril7Send( buf, RcvNum );
                    break;
                case INT_RCV_LINES:    /* ·״̬ж */
                    ReadCH438Data( REG_LSR7_ADDR);
                    break;
                case INT_RCV_OVERTIME:    /* ݳʱж */
                    RcvNum = CH438Seril7Rcv( buf );
                    CH438Seril7Send( buf, RcvNum );
                    break;
	            case INT_MODEM_CHANGE:
                    ModemStatus = ReadCH438Data( REG_MSR7_ADDR );
                    UART7_SendStr( " Modem Change \n" );
                    if ( ModemStatus == 0x30 )        /* Modemźŷݱ仯 */
                     {
//                    UART0_SendStr( SEND_STRING1 );
                      }
                    else if ( ModemStatus == 0x11 )    /* Modem źŽݱ仯 */
                     {
//                    WriteCH438Data( CH438_THR_PORT, 0xAA );
                      }
                    else if ( ModemStatus == 0x22 )    /* Modem źŽݱ仯 */
                     {
                       s = ReadCH438Data( REG_RBR7_ADDR );
//                     WriteCH438Data( CH438_THR_PORT, s );
                       }
                     break;

                default:    /* ܷж */
                    break;
            }
        }
    }
	else { }
	EX0 = 1;       /* INT0 ж */

}



/*********************************************************************************************************
** : CH438UART_INIT
** : ãڳʼCH438
** 䡡: 
**
** 䡡: 
**         
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/

void CH438UART_INIT( void )
{
  InitCH438UART0( );
  InitCH438UART1( );
  InitCH438UART2( );
  InitCH438UART3( );
  InitCH438UART4( );
  InitCH438UART5( );
  InitCH438UART6( );
  InitCH438UART7( );

}




/*
   
*/
void main( void )
{
  mDelay100mS();

  InitStdio();

  CH438_PORT_INIT( );

  CH438UART_INIT( );

  printf("start \n");


  mDelay100mS();

  EX0 = 1;      /* Ƭⲿж0 */
  IT1 = 0;		/* жϴʽ ƽ */
  EA = 1;		/* ж */

  while(1)
  {
  	UART0_SendStr(UART0_STRING);
  	UART1_SendStr(UART1_STRING);
  	UART2_SendStr(UART2_STRING);
  	UART3_SendStr(UART3_STRING);
  	UART4_SendStr(UART4_STRING);
  	UART5_SendStr(UART5_STRING);
  	UART6_SendStr(UART6_STRING);
  	UART7_SendStr(UART7_STRING);
  }

}








