/* 2011.8.26
****************************************
**  Copyright  (C)        1999-2011   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  TC2.0@PC, KC7.0@MCS51             **
****************************************
*/

/*
********************************************** 
**
**  ʼCH438 1 
**
**********************************************
*/

#include"include.h"

/*
  ĬϵⲿʱƵ22.1184MHZ
*/
#define CH438UART1_BPS  2400            /* CH4381ͨѶ */
#define Fpclk           1843200         /* ڲʱƵ    */


/*********************************************************************************************************
** : InitCH438UART1
** : ãڳʼCH4381
** 䡡: 
**
** 䡡: 
**         
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/

void InitCH438UART1( void )       
{
    UINT16 div;
    UINT8 DLL, DLM;
/**************************************************************************
          CH4381ļĴ
**************************************************************************/
    div = ( Fpclk >> 4 ) / CH438UART1_BPS;
    DLM = div >> 8;
    DLL = div & 0xff;
    WriteCH438Data( REG_LCR1_ADDR, BIT_LCR_DLAB );    /* DLABΪ1 */
    WriteCH438Data( REG_DLL1_ADDR, DLL );             /* ò */
    WriteCH438Data( REG_DLM1_ADDR, DLM );

    WriteCH438Data( REG_FCR1_ADDR, BIT_FCR_RECVTG1 | BIT_FCR_RECVTG0 | BIT_FCR_FIFOEN );    /* FIFOģʽΪ112ֽ */

    WriteCH438Data( REG_LCR1_ADDR, BIT_LCR_WORDSZ1 | BIT_LCR_WORDSZ0 );                     /* ֳ8λ1λֹͣλУ */

    WriteCH438Data( REG_IER1_ADDR, /*BIT_IER_IEMODEM |*/ BIT_IER_IELINES | BIT_IER_IETHRE | BIT_IER_IERECV );    /* ʹж */

    WriteCH438Data( REG_MCR1_ADDR, BIT_MCR_OUT2    | BIT_MCR_RTS     | BIT_MCR_DTR );              /* ж,DTR,RTSΪ1 */

    WriteCH438Data(REG_FCR1_ADDR,ReadCH438Data(REG_FCR1_ADDR)| BIT_FCR_TFIFORST|BIT_FCR_RFIFORST);

}



/*********************************************************************************************************
** : UART1_Reset
** : ܺڸλCH4381, λ֮Ҫ³ʼ ſʹ
** 䡡: 
**
** 䡡: 
**         
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void UART1_Reset( void )
{

    WriteCH438Data( REG_IER1_ADDR, BIT_IER_RESET ); 

}




/*********************************************************************************************************
** : UART1_LowPower
** : ܺCH4381͹ģʽ
** 䡡: 
**
** 䡡: 
**         
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void UART1_LowPower( void )
{

    WriteCH438Data( REG_IER1_ADDR, BIT_IER_LOWPOWER ); 

}




/*********************************************************************************************************
** : UART1_SendByte
** : ܺCH4381 ͵ֽ
** 䡡: 
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void UART1_SendByte( UINT8 dat )    
{

    while( ( ReadCH438Data( REG_LSR1_ADDR ) & BIT_LSR_THRE ) == 0 );    /* ȴݷ */

    WriteCH438Data( REG_THR1_ADDR, dat );
}




/*********************************************************************************************************
** : UART1_RcvByte
** : ܺCH4381 յֽ
** 䡡: 
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
UINT8 UART1_RcvByte( void )    
{

    UINT8 Rcvdat;

    if( !( ReadCH438Data( REG_LSR1_ADDR ) & ( BIT_LSR_BREAKINT | BIT_LSR_FRAMEERR | BIT_LSR_PARERR | BIT_LSR_OVERR ) ) )    /*  b1-b4޴ */
    {

        while( ( ReadCH438Data( REG_LSR1_ADDR ) & BIT_LSR_DATARDY ) == 0 );    /* ȴ׼ */

        Rcvdat = ReadCH438Data( REG_RBR1_ADDR );    /* ӽջĴ */

        return( Rcvdat );
    }

    else ReadCH438Data( REG_RBR1_ADDR );    /* д */

}





/*********************************************************************************************************
** : UART1_SendStr
** : ܺCH4381 һַ
** 䡡: ַ
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void UART1_SendStr( UINT8 *str )    
{

    while( 1 )
    {

        if( *str == '\0' ) break;

        UART1_SendByte( *str++ );

    }

}


/*********************************************************************************************************
** : CH438Seril1Send
** : ܺFIFOģʽ, CH4381 Ͷֽ
** 䡡: ݿ
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void  CH438Seril1Send( UINT8 *Data, UINT8 Num )
{
    do
    {

        while( ( ReadCH438Data( REG_LSR1_ADDR ) & BIT_LSR_THRE ) == 0 );    /* ȴݷ */

        WriteCH438Data( REG_THR1_ADDR, *Data++ );

    }

    while( --Num );

}



/*********************************************************************************************************
** : CH438Seril1Rcv
** : ܺFIFOģʽ, CH4381 նֽ
** 䡡: ݻַ
**
** 䡡: ݳ
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/

UINT8  CH438Seril1Rcv( UINT8 *buf )
{
    UINT8 RcvNum = 0;

    if( !( ReadCH438Data( REG_LSR1_ADDR ) & ( BIT_LSR_BREAKINT | BIT_LSR_FRAMEERR | BIT_LSR_PARERR | BIT_LSR_OVERR ) ) )    /* b1-b4޴ */
    {

        while( ( ReadCH438Data( REG_LSR1_ADDR ) & BIT_LSR_DATARDY ) == 0 );    /* ȴ׼ */

        do
        {

            *buf++ = ReadCH438Data( REG_RBR1_ADDR );                           /* ӽջĴ */

            RcvNum++;

        }

        while( ( ReadCH438Data( REG_LSR1_ADDR ) & BIT_LSR_DATARDY ) == 0x01 );
									   
    }

    else ReadCH438Data( REG_RBR1_ADDR );

    return( RcvNum );
}








/*********************************************************************************************************
** : CH438UART1Send
** : ܺFIFOģʽ, CH4381 Ͷֽ ෢128ֽ
** 䡡: ݻַ, ݿ鳤
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void  CH438UART1Send( UINT8 *Data, UINT8 Num )
{

    while( 1 )
    {

        while( ( ReadCH438Data( REG_LSR1_ADDR ) & BIT_LSR_TEMT ) == 0 );    /* ȴݷϣTHR,TSRȫ */

        if( Num <= 128 )
        {

            WriteCH438Block( REG_THR1_ADDR, Num, Data );

            break;

        }

        else
        {

            WriteCH438Block( REG_THR1_ADDR, 128, Data );

            Num -= 128;

            Data += 128;

        }

    }
}



/*********************************************************************************************************
** : Auto_HandFlow1_Ctrl
** : ܺ1ԶӲ
** 䡡: 
**
** 䡡: 
**
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void Auto_HandFlow1_Ctrl( void )
{

    WriteCH438Data( REG_MCR1_ADDR, BIT_MCR_AFE | BIT_MCR_OUT2 | BIT_MCR_RTS );    /* MCRĴAFERTSΪ1 */

}


