/* 2011.8.26
****************************************
**  Copyright  (C)        1999-2011   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  TC2.0@PC, KC7.0@MCS51             **
****************************************
*/

/*
********************************************** 
**
**  CH438 תമڽӿоƬ 
**
**  Ӳӿڲ㶨 ֱӵַʽ   
**
**********************************************
*/


#include"include.h"


/*

    CH438ж

*/
#define CH438_INT_WIRE    P3^2



/*
  ƬIO˿ģʱ
*/
#define CH438_ADDR_PORT    P2	 /* ֱӵַʽ ַ˿ */
#define CH438_DATA_PORT    P0	 /* ֱӵַʽ ݶ˿ */

sbit CH438_WR_WIRE    = P3^6;    /* WR */

sbit CH438_RD_WIRE    = P3^7;    /* RD */

sbit CH438_CS_WIRE    = P1^2;    /* CS */


/*
   ֱӵַʽ
*/

/*********************************************************************************************************
** : WriteCH438Data
** : ӿںCH438ַд
** 䡡: ַ,
**
** 䡡: 
**         
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void WriteCH438Data( UINT8 addr, UINT8 dat)
{

/*
    ʹ51Ƭⲿ߽ӿڲCH438
	Ӳӿ 
	     MCU			CH438
	  P0.0~P0.7  <==>	D0~D7
	  P2.0~P2.6  <==>   A0~A6
	     WR      <==> 	WR
         RD      <==>	RD
		 P1.2    <==>   CS
		 P3.2    <==> 	INT
*/
//	CH438_CS_WIRE = 0;
//	*((volatile unsigned char  xdata *)(0x8000|(addr<<8)))  = dat;	/* ռõƬߵַռ0x8000~0x804F */
//	CH438_CS_WIRE = 1;



/*
    ʹõƬͨIO˿ģֱӵַʱ

	Ӳӿ 
	     MCU			CH438
	  P0.0~P0.7  <==>	D0~D7
	  P2.0~P2.7  <==>	D0~D7
	     P3.6    <==> 	WR
         P3.7    <==>	RD
		 P1.2    <==>   CS
		 P3.2    <==> 	INT
*/
     CH438_ADDR_PORT = addr;
	 CH438_DATA_PORT = dat;
	 CH438_CS_WIRE = 0;
	 CH438_WR_WIRE = 0;
	 CH438_WR_WIRE = 1;
	 CH438_CS_WIRE = 1;
	 CH438_ADDR_PORT = 0xff;     /* Ϊ뷽 */
	 CH438_DATA_PORT = 0xff;	 /* Ϊ뷽 */
}








/*********************************************************************************************************
** : ReadCH438Data
** : ӿںCH438ַȡ
** 䡡: ַ
**
** 䡡: 
**         
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
UINT8 ReadCH438Data( UINT8 addr )
{
  UINT8 dat;
  dat = dat;      /* ֹ־ */

/*
    ʹ51Ƭⲿ߽ӿڲCH438
	Ӳӿ 
	     MCU			CH438
	  P0.0~P0.7  <==>	D0~D7
	  P2.0~P2.6  <==>   A0~A6
	     WR      <==> 	WR
         RD      <==>	RD
		 P1.2    <==>   CS
		 P3.2    <==> 	INT
*/
//    CH438_CS_WIRE = 0;
//	dat = *((volatile unsigned char   xdata *)(0x8000|(addr<<8)));	   /* ռߵַռ0x8000~0x804F */
//    CH438_CS_WIRE = 1;

//	return (dat);	



/*
    ʹõƬͨIO˿ģֱӵַʱ

	Ӳӿ 
	     MCU			CH438
	  P0.0~P0.7  <==>	D0~D7
	  P2.0~P2.7  <==>	D0~D7
	     P3.6    <==> 	WR
         P3.7    <==>	RD
		 P1.2    <==>   CS
		 P3.2    <==> 	INT
*/
     CH438_ADDR_PORT = addr;
	 CH438_DATA_PORT = 0xff;   	/* Ϊ뷽 */
	 CH438_CS_WIRE = 0;
	 CH438_RD_WIRE = 0;
	 dat = CH438_DATA_PORT;
	 CH438_RD_WIRE = 1;
	 CH438_CS_WIRE = 1;
	 CH438_ADDR_PORT = 0xff;     /* Ϊ뷽 */
	 CH438_DATA_PORT = 0xff;	 /* Ϊ뷽 */
	return (dat);

}









/*********************************************************************************************************
** : WriteCH438Block
** : ӿںCH438ַдݿ
** 䡡: CH438Ĵַ,ݿ鳤,ݻַ
**
** 䡡: 
**         
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void WriteCH438Block( UINT8 mAddr, UINT8 mLen, PUINT8 mBuf )   
{

    while ( mLen -- ) 	
	  WriteCH438Data( mAddr, *mBuf++ );

}





/*********************************************************************************************************
** : Query438Interrupt
** : ӿںڲѯжϷʽ
** 䡡: 
**
** 䡡: 
**         
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
UINT8 Query438Interrupt( void )
{
#ifdef CH432_INT_WIRE
    return( CH432_INT_WIRE ? FALSE : TRUE );   /* CH438жֱӽжϷ */
#else 
    return( 1 );
#endif

}












/*********************************************************************************************************
** : CH438_PORT_INIT
** : ӿںڳʼƬIO
** 䡡: 
**
** 䡡: 
**         
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void CH438_PORT_INIT( void )
{

  CH438_ADDR_PORT = 0xff;		/* ַ˿ ĬΪ뷽 */

  CH438_DATA_PORT = 0xff;		/* ݶ˿ ĬΪ뷽 */

  CH438_CS_WIRE = 1;			/* CSЧ */

  CH438_WR_WIRE = 1;			/* WRЧ */

  CH438_RD_WIRE = 1;			/* RDЧ */

}